// Example for adding to the custom speedcap table stuff. In this case, it's MonitorsPlus, which
// is expected to be loaded before Windows as there's also MonitorPlus support baked in directly.
// Note that these may not work well, if at all, with momentum-changing addons. Looking at you, CrossMomentum.

// Is the recent version of Windows The Computer loaded?
if not WindowsTheComputer then return end

// Access the table via a local.
local speedtable = WindowsTheComputer.SpeedSource

// The functions in the table should return a speed value. Do not do any size comparisons as
// the function that cycles through the functions in the table already does so anyway.
// Aside from the name of the addon the script adds support for, as well as sorting from lowest
// to highest max speed, as long as you return a speed value and have the function inserted into
// the table, everything else can be done however you wish.
local function MonitorsPlusSupport(p, name)
	if name then CONS_Printf(p, "MonitorsPlus") return end // Name your external function like so.
	if monitorsplus and p and p.valid and p.mo and p.mo.valid and p.mo.MP_effects then
		local compare, effect = 0, p.mo.MP_effects
		// Sorting through low to high...
		if effect[ef_divided] then
			compare = max($, skins[p.mo.skin].normalspeed/2)
		elseif effect[ef_hypersneakers] then
			compare = max($, 106*p.mo.scale)
		elseif effect[ef_hyper] then
			compare = max($, skins[p.mo.skin].normalspeed*5/2)
		end
		if CV_FindVar("windbg").value then CONS_Printf(p, "Result from MonitorsPlus: " .. compare + " / " + compare/FRACUNIT) end // Unnecessary, but could prove useful.
		return compare // Return the top speed, even if it hasn't been changed from 0.
	end
end

// Insert function into the aforementioned table. We're done!
table.insert(speedtable, MonitorsPlusSupport)

// Hyper-esque forms and such that are not CrossMomentum.
// A surprise third modular thing, eh?
local customhyper = WindowsTheComputer.HyperDef
local function MonPlusHyper(p, name)
	if name then CONS_Printf(p, "MonitorsPlus Hyper") return end
	if monitorsplus and p and p.valid and p.mo and p.mo.valid and p.mo.MP_effects then
		if p.mo.MP_effects[ef_hyper] then return true else return false end
	end
end
table.insert(customhyper, MonPlusHyper)