// MRCE.
WindowsTheComputer.MRCEShieldTable = {SH_WHIRLWIND,SH_ARMAGEDDON,SH_ELEMENTAL,SH_ATTRACT,SH_FLAMEAURA,SH_BUBBLEWRAP,SH_THUNDERCOIN,(SH_FORCE|1)}
local shieldtable = WindowsTheComputer.MRCEShieldTable
function WindowsTheComputer.WinMRCECompact(p)
	if not (p and p.valid and p.mo and p.mo.valid and p.mo.skin == "windows") return end
	if p.mrce then
		p.mrce.customskin = 2
		p.mrce.ultrastar = true
		if gamemap == 164 and not netgame and p.powers[pw_super] and p.xpsuper then
			if p.playerstate == 0 or p.playerstate == 2 then p.mo.color = SKINCOLOR_NEWERAPC
			else p.mo.color = p.skincolor end
		end
		// Windows has been lead to a strange (instruction) path...
		if gamemap == 121 and (mr_portalopener == 8 or mrce.agz_portalopener == 8) and p.mo.state == S_PLAY_PAIN then
			if p.powers[pw_nocontrol] != 0 and p.mo.state == S_PLAY_PAIN and p.panim == PA_PAIN and p.exiting == 0 then
				if p.powers[pw_super] != 0 then p.powers[pw_super] = 0 end
				if leveltime%2 == 1 then
					p.mo.color = P_RandomRange(1, #skincolors-1)
					if P_RandomChance(FRACUNIT/2) then
						p.mo.colorized = true
					else
						p.mo.colorized = false
					end
					local poof = P_SpawnGhostMobj(p.mo)
					if poof.thrust == nil then
						P_InstaThrust(poof, ANG1*P_RandomRange(0, 359), P_RandomRange(16, 128)*FRACUNIT)
						P_SetObjectMomZ(poof, P_RandomRange(-32, 32)*FRACUNIT)
						poof.scalespeed = P_RandomRange(0, 4)*$
						if P_RandomChance(FRACUNIT/2) then
							poof.destscale = P_RandomRange(0, 16)*$
						else
							poof.destscale = $/P_RandomRange(1, 16)
						end
						poof.thrust = true
					end
				end
				p.baudrate = 0
				p.mo.rollangle = $*P_RandomRange(2, 4)
				p.mrce.speen = $+P_RandomRange(5, 50)*ANG1
				if not netgame then
					p.dxready = false
					p.winpopup = P_RandomRange(0, 15)*P_RandomRange(0, TICRATE)
					p.rings = P_RandomRange(0, 99)
					p.powers[pw_shield] = (shieldtable[P_RandomRange(1,#shieldtable)])
					p.powers[pw_sneakers] = P_RandomRange(0, 1)
					p.powers[pw_invulnerability] = P_RandomRange(0, 1)
					S_StopMusic(p)
				end
			elseif p.exiting >= 2 then
				if p.mo.color != p.skincolor then p.mo.color = p.skincolor end
				if not netgame then
					p.winpopup = nil
					p.powers[pw_shield] = 0
					p.powers[pw_sneakers] = 0
					p.powers[pw_invulnerability] = 0
				end
				S_StopMusic(p)
			end
		end
		if p.mrce.hud == 1 and p.dxhudshift == 0 then
			CV_StealthSet(CV_FindVar("dxhudalt"), 1)
			if p.dxhudalt != true then p.dxhudalt = true end
			p.dxhudshift = 16
		end
	end
end
addHook("PlayerThink", WindowsTheComputer.WinMRCECompact)

function WindowsTheComputer.WinNetscapeMind(p)
	if not (p and p.valid and p.mo and p.mo.valid and p.mo.skin == "windows") return end
	// Start compatibility with (no longer bound to a wheelchair) Inazuma!
	if p.stuckininazumashead == nil
		p.stuckininazumashead = false 
		p.watermessageran = false
	end
	
	if mapheaderinfo[gamemap].mindscape then
		if not (p.charflags & SF_RUNONWATER) then
			p.charflags = $ | (SF_RUNONWATER)
		end
		if not p.stuckininazumashead then p.stuckininazumashead = true end
		p.runspeed = skins[p.mo.skin].normalspeed/3 // Overclocking.
		if p.winpopup < 10*TICRATE-1 and not p.dxready then p.winpopup = $+1 end
		// Prepare to fly..! Or, well, float.
		// Did you know "Prepare to fly!" was XP's original slogan?
		if not P_IsObjectOnGround(p.mo) then P_SetObjectMomZ(p.mo, 3*gravity/10, true) end
		if globallevelskynum == 8 then // Assuming we're in the collapse phase of Mindscape...
			if p.powers[pw_super] >= 1 then
				if p.mo.color != SKINCOLOR_NEWERAPC then p.mo.color = SKINCOLOR_NEWERAPC end
				if p.baudrate < 17 then p.baudrate = 17 end
				if not p.mo.colorized then p.mo.colorized = true end
			elseif p.powers[pw_super] == 0 and p.mo.color == SKINCOLOR_NEWERAPC then
				p.mo.color = p.skincolor
				p.mo.colorized = false
			end
		end
	end
	if not mapheaderinfo[gamemap].mindscape and (p.charflags & SF_RUNONWATER) and p.stuckininazumashead then
		p.stuckininazumashead = false
		p.charflags = $1 & ~(SF_RUNONWATER)
		p.watermessageran = false
		p.runspeed = skins[p.mo.skin].runspeed
	end
end
addHook("PlayerThink", WindowsTheComputer.WinNetscapeMind)