// Tokens & Windows, KeepShield, CrossMomentum compatibility and other stuff.

if not WindowsTheComputer then return end
freeslot("SFX_FUNDIE", "SFX_MUSMN1", "SFX_MUSMN2")

sfxinfo[sfx_fundie] = {
	singular = false,
	priority = 32,
	flags = SF_X4AWAYSOUND,
	caption = "funnydeath.mp4"
}

sfxinfo[sfx_musmn1] = {
	singular = false,
	priority = 50,
	caption = "Musica Menu Popup"
}

sfxinfo[sfx_musmn2] = {
	singular = false,
	priority = 50,
	caption = "Musica Menu Command"
}

sfxinfo[sfx_cdfm67].caption = "Ring Spill"
sfxinfo[sfx_cdfm73].caption = "Special success!"

if srb2p then return end

local netframework = CV_RegisterVar({ // Compromise with having default special stages.
	name = "TokenCompile",
	defaultvalue = 0,
	flags = CV_NETVAR | CV_SHOWMODIF,
	PossibleValue = {default=0, legacy=1},
	func = WindowsTheComputer.DoKartCallBackSound
})

local function Token2GemSFX()
	S_StartSound(nil, sfx_cgot)
	S_StartSound(nil, sfx_chchng)
end

local function TokenWindowsReward()
	for player in players.iterate
		P_GivePlayerRings(player, 50) // Rings, people, Rings!
		S_StartSound(player.mo, sfx_cdfm67, player)
	end
end

// The old special stages continue Lua.
// Script by SteelT.
local therings = 0
local roundedcorners = 0
local gotem = false

addHook("MapLoad", function(gamemap)
	therings = 0
	roundedcorners = 0
	gotem = false
	if (multiplayer) then return end
	if (maptol & TOL_NIGHTS) then return end
	if (G_IsSpecialStage(gamemap)) then
		for item in mobjs.iterate() do
			if (item.type == MT_RING) then therings = $ + 1 end
			if (item.type == MT_BLUESPHERE) then roundedcorners = $ + 1 end
		end
		for player in players.iterate
			if player.mo and player.mo.valid and player.mo.skin == "windows" then player.getsphere = 0 end
		end
	end
end)

addHook("TouchSpecial", function(special, play)
	if (multiplayer) or (maptol & TOL_NIGHTS) then return end
	if (play and play.valid) and play.skin == "windows" and play.player and play.player.valid then
		if play.player.getsphere < roundedcorners then play.player.getsphere = $ + 1 end
		if CV_FindVar("windbg").value then print(play.player.getsphere) end
	end
end, MT_BLUESPHERE)

addHook("PlayerThink", function(player)
	if player.mo.skin != "windows" then return end
	if (multiplayer) then return end
	if (maptol & TOL_NIGHTS) then return end
	if (G_IsSpecialStage(gamemap)) then
		if (therings > 0 and player.rings >= therings/2) and not player.gotcontinue then
			player.gotcontinue = 1
			player.continues = $ + 1
			S_StartSound(nil, sfx_s3kac, player)
		end
		if (roundedcorners > 0 and player.getsphere >= roundedcorners - 2) and (player.rings >= therings) and not gotem then
			gotem = true
			player.rings = $ + 1000
			S_StartSound(nil, sfx_cdfm73, player)
		end
		if player.exiting > 0 and player.gotcontinue then
			if leveltime%5 == 1 then
				local glow = P_SpawnGhostMobj(player.mo)
				glow.destscale = player.mo.scale*32
				glow.flags = $ & ~MF_NOCLIPHEIGHT
			end
		end
	end
end)

// From KeepShield V3 by Zippy_Zolton.
// Be smart with which shield you finish a level with.
// Might help you or end up being useless.
addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin != "windows" then return
	elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		if not (player and player.mo and player.mo.valid and player.exiting and (gametyperules & GTR_FRIENDLY)) return end
		player.shieldtransfer = player.powers[pw_shield]
	end
end)

addHook("PlayerSpawn", function(player)
	if (player.mo and player.mo.valid) then
		if player.shieldtransfer == nil or not (gametyperules & GTR_FRIENDLY) then return end
		if player.mo.skin != "windows" then return
		elseif player.mo.skin == "windows" then
			player.powers[pw_shield] = player.shieldtransfer
			P_SpawnShieldOrb(player)
			player.shieldtransfer = nil
		end
	end
end)

// Actual token shenanigans.
addHook("TouchSpecial", function(special, grabber)
	if (grabber and grabber.valid) and grabber.skin != "windows" then return
	elseif (grabber and grabber.valid) and grabber.skin == "windows" then
		if not OLDC then
			if netframework.value == 1 then
				if emeralds & EMERALD1 == 0 then
					emeralds = $ | EMERALD1
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD2 == 0 then
					emeralds = $ | EMERALD2
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD3 == 0 then
					emeralds = $ | EMERALD3
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD4 == 0 then
					emeralds = $ | EMERALD4
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD5 == 0 then
					emeralds = $ | EMERALD5
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD6 == 0 then
					emeralds = $ | EMERALD6
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD7 == 0 then
					emeralds = $ | EMERALD7
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				else TokenWindowsReward() end
			else
				if not All7Emeralds(emeralds) then
					token = $ + 1
					S_StartSound(grabber, sfx_zelda)
				else
					TokenWindowsReward()
				end
				P_AddPlayerScore(grabber.player, 2500)
				S_StartSound(grabber, sfx_chchng)
			end
			P_KillMobj(special)
			return true
		end
	end
end, MT_TOKEN)

// CrossMomentum-compatible setting of speed cap.
local function ShadowCache(p, input)
	if (p.isxmomentum and not p.xmomtoggledoff) then
		p.fakenormalspeed = input
	else
		p.normalspeed = input
	end
end

// Do we have a special effect active?
local function IsSpecialEffectActive(p, var)
	local speedsource, check = WindowsTheComputer.SpeedSource, 0
	var = $ or skins[p.mo.skin].normalspeed
	for i = 1, #speedsource do
		local result = speedsource[i](p)
		if result != nil and result > check then
			check = result
		end
	end
	
	if FixedMul(check, p.mo.scale) > FixedMul(var, p.mo.scale) then return true else return false end
end

// Or non-XMomentum Hyper?
local function IsSpecialHyper(p)
	local customhyper = WindowsTheComputer.HyperDef
	for i = 1, #customhyper do
		if customhyper[i](p) then return true else return false end
	end
	return false
end

// CrossMomentum-compatibile custom top speeds.
// Dashmode included.
addHook("ThinkFrame", function()
	for p in players.iterate
		if (p.mo and p.mo.valid) and p.mo.skin != "windows" then return
		elseif (p.mo and p.mo.valid) and p.mo.skin == "windows" then
			// This is the original top speed logic... but with the top speed values not directly being set...
			local speedvalue
			if (p.isxmomentum and not p.xmomtoggledoff) and p.fakenormalspeed < skins[p.mo.skin].normalspeed then
				//p.fakenormalspeed = skins[p.mo.skin].normalspeed
				speedvalue = skins[p.mo.skin].normalspeed
			elseif not p.isxmomentum or p.normalspeed < skins[p.mo.skin].normalspeed then
				//p.normalspeed = skins[p.mo.skin].normalspeed
				speedvalue = skins[p.mo.skin].normalspeed
			end
			if not P_IsObjectOnGround(p.mo) and p.cpucooler then
				if (p.isxmomentum and not p.xmomtoggledoff) and p.fakenormalspeed < (skins[p.mo.skin].normalspeed * 3) / 2 then
					//p.fakenormalspeed = (skins[p.mo.skin].normalspeed * 3) / 2
					speedvalue = (skins[p.mo.skin].normalspeed * 3) / 2
				elseif not p.isxmomentum or p.normalspeed < (skins[p.mo.skin].normalspeed * 3) / 2 then
					//p.normalspeed = (skins[p.mo.skin].normalspeed * 3) / 2
					speedvalue = (skins[p.mo.skin].normalspeed * 3) / 2
				end
			elseif (p.powers[pw_invulnerability] != 0 and p.powers[pw_sneakers] == 0) then
				if (p.isxmomentum and not p.xmomtoggledoff) and p.fakenormalspeed < (skins[p.mo.skin].normalspeed * 4) / 3 then
					//p.fakenormalspeed = (skins[p.mo.skin].normalspeed * 4) / 3
					speedvalue = (skins[p.mo.skin].normalspeed * 4) / 3
				elseif not p.isxmomentum or p.normalspeed < (skins[p.mo.skin].normalspeed * 4) / 3 then
					//p.normalspeed = (skins[p.mo.skin].normalspeed * 4) / 3
					speedvalue = (skins[p.mo.skin].normalspeed * 4) / 3
				end
			elseif p.powers[pw_sneakers] != 0 then
				if (p.isxmomentum and not p.xmomtoggledoff) and p.fakenormalspeed < (skins[p.mo.skin].normalspeed * 5) / 4 then
					//p.fakenormalspeed = (skins[p.mo.skin].normalspeed * 5) / 4
					speedvalue = (skins[p.mo.skin].normalspeed * 5) / 4
				elseif not p.isxmomentum or p.normalspeed < (skins[p.mo.skin].normalspeed * 5) / 4 then
					//p.normalspeed = (skins[p.mo.skin].normalspeed * 5) / 4
					speedvalue = (skins[p.mo.skin].normalspeed * 5) / 4
				end
			else
				if (p.isxmomentum and not p.xmomtoggledoff) and p.fakenormalspeed > skins[p.mo.skin].normalspeed then
					//p.fakenormalspeed = skins[p.mo.skin].normalspeed
					speedvalue = skins[p.mo.skin].normalspeed
				elseif not p.isxmomentum or p.normalspeed < skins[p.mo.skin].normalspeed then
					//p.normalspeed = skins[p.mo.skin].normalspeed
					speedvalue = skins[p.mo.skin].normalspeed
				end
			end
			if p.powers[pw_super] != 0 or (p.solchar and p.solchar.istransformed and p.solchar.istransformed > 1) then
				if (p.isxmomentum and not p.xmomtoggledoff) then
					if p.hyper and p.hyper.capable then
						//p.fakenormalspeed = (skins[p.mo.skin].normalspeed * 3)
						speedvalue = (skins[p.mo.skin].normalspeed * 3)
					else
						if IsSpecialHyper(p) then
							speedvalue = (skins[p.mo.skin].normalspeed * 5) / 2
						elseif (p.solchar and p.solchar.istransformed and p.solchar.istransformed > 1)
						and p.fakenormalspeed < (skins[p.mo.skin].normalspeed * 7) / 3 then
							//p.fakenormalspeed = (skins[p.mo.skin].normalspeed * 7) / 3
							speedvalue = (skins[p.mo.skin].normalspeed * 7) / 3
						else
							//p.fakenormalspeed = (skins[p.mo.skin].normalspeed * 3) / 2
							speedvalue = (skins[p.mo.skin].normalspeed * 3) / 2
						end
					end
				else
					if IsSpecialHyper(p) then
						speedvalue = (skins[p.mo.skin].normalspeed * 5) / 2
					elseif (p.solchar and p.solchar.istransformed and p.solchar.istransformed > 1)
					and p.normalspeed < (skins[p.mo.skin].normalspeed * 7) / 3 then
						//p.normalspeed = (skins[p.mo.skin].normalspeed * 7) / 3
						speedvalue = (skins[p.mo.skin].normalspeed * 7) / 3
					else
						//p.normalspeed = (skins[p.mo.skin].normalspeed * 3) / 2
						speedvalue = (skins[p.mo.skin].normalspeed * 3) / 2
					end
				end
			end
			// Top speeds when DirectX Boosting... or you managed to get Windows to use dashmode.
			if p.cpanel > 0 or (p.charflags & SF_DASHMODE and p.dashmode >= 3*TICRATE) and p.pstate == PST_LIVE then
				if p.exiting != 0 then p.cpanel = 0 end
				if P_PlayerInPain(p) == true then p.cpanel = 0 end
				if (p.charflags & SF_DASHMODE and p.dashmode >= 3*TICRATE) and p.cpanel > 0 then p.cpanel = 0 end
				p.thrustfactor = (skins[p.mo.skin].thrustfactor * 7) / 4
				if p.powers[pw_super] == 0 and not (p.solchar and p.solchar.istransformed and p.solchar.istransformed > 1) then
					if (p.isxmomentum and not p.xmomtoggledoff) and p.fakenormalspeed < (skins[p.mo.skin].normalspeed * 9) / 4 then
						//p.fakenormalspeed = (skins[p.mo.skin].normalspeed * 9) / 4
						speedvalue = (skins[p.mo.skin].normalspeed * 9) / 4
					elseif not p.isxmomentum or p.normalspeed < (skins[p.mo.skin].normalspeed * 9) / 4 then
						//p.normalspeed = (skins[p.mo.skin].normalspeed * 9) / 4
						speedvalue = (skins[p.mo.skin].normalspeed * 9) / 4
					else
						if p.dashmode >= 3*TICRATE and p.charflags & SF_DASHMODE and p.normalspeed < (skins[p.mo.skin].normalspeed * 9) / 4 then
							//p.normalspeed = (skins[p.mo.skin].normalspeed * 9) / 4
							speedvalue = (skins[p.mo.skin].normalspeed * 9) / 4
						end
					end
				elseif p.powers[pw_super] != 0 or (p.solchar and p.solchar.istransformed and p.solchar.istransformed > 1) then
					if (p.isxmomentum and not p.xmomtoggledoff) then
						if (p.hyper and p.hyper.capable) or IsSpecialHyper(p) then
							if p.fakenormalspeed < (skins[p.mo.skin].normalspeed * 6) then
								//p.fakenormalspeed = (skins[p.mo.skin].normalspeed * 6)
								speedvalue = (skins[p.mo.skin].normalspeed * 6)
							end
						else
							if IsSpecialHyper(p) then
								speedvalue = (skins[p.mo.skin].normalspeed * 5)
							elseif (p.solchar and p.solchar.istransformed and p.solchar.istransformed > 1) and p.fakenormalspeed < (skins[p.mo.skin].normalspeed * 11) / 3 then
								//p.fakenormalspeed = (skins[p.mo.skin].normalspeed * 11) / 3
								speedvalue = (skins[p.mo.skin].normalspeed * 11) / 3
							else
								if p.fakenormalspeed < (skins[p.mo.skin].normalspeed * 3) then
									//p.fakenormalspeed = (skins[p.mo.skin].normalspeed * 3)
									speedvalue = (skins[p.mo.skin].normalspeed * 3)
								end
							end
						end
					else
						if IsSpecialHyper(p) then
							speedvalue = (skins[p.mo.skin].normalspeed * 5)
						elseif (p.solchar and p.solchar.istransformed and p.solchar.istransformed > 1) and p.normalspeed < (skins[p.mo.skin].normalspeed * 11) / 3 then
							//p.normalspeed = (skins[p.mo.skin].normalspeed * 11) / 3
							speedvalue = (skins[p.mo.skin].normalspeed * 11) / 3
						else
							if p.normalspeed < (skins[p.mo.skin].normalspeed * 3) then
								//p.normalspeed = (skins[p.mo.skin].normalspeed * 3)
								speedvalue = (skins[p.mo.skin].normalspeed * 3)
							end
						end
					end
				end
			end
			// ...yet. Let's see if we have a special thing happening.
			if not IsSpecialEffectActive(p, speedvalue) then
				ShadowCache(p, speedvalue)
			end
		end
	end
end)

// The Funny Switch.
local funnydeath = CV_RegisterVar({
	name = "funindeath",
	defaultvalue = 1,
	flags = CV_NETVAR | CV_SHOWMODIF | CV_CALL,
	PossibleValue = {disabled=0, enabled=1},
	func = WindowsTheComputer.DoKartCallBackSound
})

// Chance for a funny death no longer hardcoded.
local funnydeathchance = CV_RegisterVar({
	name = "funindeathchance",
	defaultvalue = "0.125",
	flags = CV_NETVAR | CV_SHOWMODIF | CV_CALL | CV_FLOAT,
	PossibleValue = {min = 0, max = FRACUNIT},
	func = WindowsTheComputer.DoKartCallBackSound
})

addHook("PlayerThink", function(player)
	if not (player and player.valid and player.mo and player.mo.valid) then return end
	if funnydeath.value != 1 then return end
	if player.playerstate == PST_DEAD and player.fundeath == 0 then
		if P_RandomChance(funnydeathchance.value) then
			player.mo.flags2 = $ | MF2_DONTDRAW
			local flatulence = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
			flatulence.scale = 3 << FRACBITS
			player.fundeath = 1
			player.hasfundie = true
		else
			player.fundeath = 2
		end
	end
	if player.playerstate == PST_DEAD then
		if player.fundeath == 1 then
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
			if not S_SoundPlaying(player.mo, sfx_fundie) then
				S_StopSound(player.mo)
				S_StartSound(player.mo, sfx_fundie)
			end
			player.mo.fuse = 1
			player.fundeath = 2
		end
	else
		if player.fundeath != 0 then player.fundeath = 0 end
		if player.hasfundie then player.hasfundie = false end
	end
end)

// The Jetski activities.
if not (solchars and boatchars) then return end
addHook("MobjThinker", function(mo)
	if (mo.rider and mo.rider.valid and mo.rider.health) then
		local player = mo.rider.player
		if not mo.rider.skin == "windows" then return end
		if player.pflags & PF_JUMPED then player.pflags = $ & ~PF_JUMPED end
		if mo.jumpsdone == nil then mo.jumpsdone = 0 end
		if mo.jumpdelay == nil then mo.jumpdelay = 0 end
		if mo.isjumphold == nil then mo.isjumphold = false end
		if (P_IsObjectOnGround(mo) or (mo.onwater) or (mo.wasinwater)) and mo.jumpsdone != 0 then mo.jumpsdone = 0 end
		if CV_FindVar("windbg").value then CONS_Printf(player, mo.jumpsdone + "/" + mo.jumpdelay + "/" + mo.isjumphold) end
		if player.cmd.buttons & BT_JUMP then
			if not mo.isjumphold then
				if mo.jumpsdone < 3 and mo.jumpdelay == 0 then
					mo.startjump = true
					mo.jumpsdone = $ + 1
					mo.jumpdelay = TICRATE/2
					mo.isjumphold = true
					P_SetObjectMomZ(mo, 10*FRACUNIT, false) 
					S_StartSound(mo, sfx_jskijm)
					local jumpy = P_SpawnGhostMobj(mo.rider)
					jumpy.destscale = mo.scale*4
					mo.allowjumpinwater = true
					P_ResetScore(player)
				end
			end
		else
			if mo.isjumphold then mo.isjumphold = false end
		end
		if mo.jumpdelay >= 1 then mo.jumpdelay = $ - 1 else mo.jumpdelay = 0 end
		if player.exiting > 0 then
			local p = player
			P_TeleportMove(mo.rider, mo.x, mo.y, mo.z+mo.height*2*P_MobjFlip(mo))
			p.mo.tracer = nil
			if mo.overlay.frame == 2
				mo.overlay.frame = 0
			elseif mo.overlay.frame == 3
				mo.overlay.frame = 1
			end
			p.eoiudjgjfih = true
			p.mo.noboatmount = TICRATE*3
			mo.rider.spriteyoffset = 0
			if mo.rider.health then p.mo.state = S_PLAY_FALL end
			mo.flags = $ & ~MF_NOBLOCKMAP
			mo.rider.flags2 = $&~MF2_DONTDRAW
			mo.rider.shadowscale = mo.rider.storedshadowscale
			mo.rider.storedshadowscale = nil
			if p.powers[pw_carry] == 19 p.powers[pw_carry] = 0 end
			mo.overlay.flags2 = $&~MF2_DONTDRAW
			mo.rider.rollangle = 0
			mo.rider.boattilt = 0
			if mo.gasgasgas or not (boatchars[p.mo.skin] and boatchars[p.mo.skin][1])
				S_StopSound(mo)
				S_StartSound(mo, sfx_jskidm)
			end
			P_RestoreMusic(p)
			mo.rider = nil
			p.mo.boat = nil
			S_StartSound(mo.rider, sfx_musmn2)
		end
	end
end, MT_MARINEJETSKI)