if not WindowsTheComputer then return end
if srb2p then return end

// Battlemod.
local dx = CV_FindVar("DirectX")
local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not (ScriptLoaded) and CBW_Battle then
		ScriptLoaded = true
		print("\x82\Windows: \x83\BattleMod compatibility loaded.")
		local B = CBW_Battle
		local IR95 = function(mo,doaction)
			local player = mo.player
			player.actiontext = "Infrared Blast"
			player.actionrings = 25
			if not (B.CanDoAction(player)) then player.actionstate = 0 return end	
			if player.actionstate == 0 then
				if doaction == 1 then
					player.actionstate = 1
					player.actiontime = 0
					B.PayRings(player)
					S_StartSound(mo,sfx_s3k3c)
				end
			end
			if player.actionstate == 1 then
				player.actiontime = $+1
				P_InstaThrust(mo,mo.angle,0)
				P_SetObjectMomZ(mo,P_MobjFlip(mo)*mo.scale,0)
				player.pflags = ($|PF_SPINNING)&~PF_JUMPED
				mo.state = S_PLAY_JUMP
				if player.actiontime%3 == 0 then P_SpawnThokMobj(player) end
				if player.actiontime == 1 then
					S_StartSound(mo, sfx_musmn1)
				elseif player.actiontime == 20 then
					player.actionstate = 2
					player.actiontime = 0
				end
			end
			if player.actionstate == 2 then
				player.actiontime = $+1
				B.ApplyCooldown(player,TICRATE*20)
				mo.state = S_PLAY_EDGE
				player.pflags = $&~(PF_SPINNING)
				player.drawangle = mo.angle
				if player.actiontime == 2 then
					S_StartSound(mo, sfx_musmn2)
					P_NukeEnemies(mo, mo, 768*FRACUNIT*(mo.scale/FRACUNIT))
					local irq = P_SpawnGhostMobj(mo)
					irq.destscale = mo.scale*32
					P_InstaThrust(mo, mo.angle, -mo.height/2)
					mo.state = S_PLAY_FALL
					player.actionstate = 0
				end
			end
		end
		local PriorityFunc = function(player)
			if player.actionstate == 1 then
				B.SetPriority(player,1,3,nil,1,3,"Infrared Blast")
			end
		end
		local DXExhaust = function(player)
			local maxtime = 0
			if player.cpanel > 0 and dx.value then
				if maxtime < player.cpanel then maxtime = player.cpanel end
				player.exhaustmeter = max(0,$-FRACUNIT/maxtime)
				return true
			end
			return false
		end
		local CollideFunc = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
			if not (plr[n1] and plr[n1].valid and plr[n1].playerstate == PST_LIVE)
				or not mo[n1].health
				or not mo[n1].state == S_PLAY_ROLL
				or not mo[n1].state == S_PLAY_JUMP
				or pain[n1]
				return false
			end
			if (hurt != 1 and n1 == 1) or (hurt != -1 and n1 == 2)
				S_StartSound(mo[n1], sfx_lose)
				return true
			end
		end
		CBW_Battle.SkinVars["windows"] = {
			special = IR95,
			func_priority_ext = PriorityFunc,
			func_exhaust = DXExhaust,
			func_collide = CollideFunc
		}
	end
end)

// Ringslinger NEO.
local rs_loaded = false
addHook("ThinkFrame", function()
	if RingSlinger and not rs_loaded
		rs_loaded = true;
		RingSlinger.AddWeapon({
			name = "File",
			viewsprite = "FILEFOLDER",
			hudsprite = "FILEHUD",
			mt = MT_WINFILE,
			sound = sfx_fileth,
			scale = (9*FRACUNIT)/4,
			viewoffset = -20*FRACUNIT,
			auto = true,
			delay = 20,
			shake = 1,
			cost = 6
		})
		RingSlinger.Skins["windows"] = {
			ammo = 32,
			weapons = {RSWPN_FILE, RSWPN_RAIL}
		}
		print("\x82\Windows: \x83\RingSlinger support loaded.")
	end
end)