// I/O for Windows. Automatically saves/loads settings for Windows,
// as well as giving the user the ability to save manually.
// Again, unless it's Persona or too old.

if not WindowsTheComputer then return end
if srb2p then return end

local autoio = false
local autoexec = io.openlocal("client/windows/autoexec.dat")
if autoexec then
	local value = 0
	value = autoexec:read()
	value = tonumber(value)
	if value == 0 then
		autoio = false
	else
		autoio = true
	end
end

// Client-side.
local music = CV_FindVar("canyon.mid")
local windbg = CV_FindVar("windbg")
local dxhudalt = CV_FindVar("dxhudalt")
local flash = CV_FindVar("winflash")
local clock = CV_FindVar("wintimer")
local kartsound = CV_FindVar("kartcallbacksound")
// Server-side.
local kart = CV_FindVar("kartgrow")
local dx = CV_FindVar("DirectX")
local bubble = CV_FindVar("winbubble")
local token = CV_FindVar("TokenCompile")
local ssd = CV_FindVar("ssd")
local funny = CV_FindVar("funindeath")
local funnychance = CV_FindVar("funindeathchance")
local dxh = CV_FindVar("dxcooprangeh")
local dxv = CV_FindVar("dxcooprangev")
local gifty = CV_FindVar("wingift")

// Client.
if io.openlocal("client/windows/system.dat") == nil then
	print("\x85\Missing client configuration file, generating a default one...")
	local restore = io.openlocal("client/windows/system.dat", "w+")
	restore:write(music.value, "\n", windbg.value, "\n", dxhudalt.value, "\n", flash.value, "\n", clock.value, "\n", kartsound.value)
	restore:close()
	if WindowsTheComputer.isdebug then print("Closing the file handle...") end
end

// Server.
if io.openlocal("client/windows/explorer.dat") == nil then
	print("\x85\Missing server configuration file, generating a default one...")
	local generate = io.openlocal("client/windows/explorer.dat", "w+")
	generate:write(kart.value, "\n", dx.value, "\n", bubble.value, "\n", token.value, "\n", ssd.value, "\n", funny.value, "\n", funnychance.value, "\n", dxh.value, "\n", dxv.value, "\n", gifty.value)
	generate:close()
	if WindowsTheComputer.isdebug then print("Closing the file handle...") end
end

// Thanks, MACHTURNE!
local function fixedToFloat(n)
	local str = (n < 0 and "-" or "") .. tostring(abs(n)/FRACUNIT)
	if not (n % FRACUNIT) then return str end
	n = abs(n) % FRACUNIT
	str = $ .. "."
	while n > 0 do
		n = $ * 10
		str = $ .. tostring(n >> FRACBITS)
		n = $ & (FRACUNIT-1)
	end
	return str
end

COM_AddCommand("registry", function(p, arg)
	if arg then
		arg = arg:lower()
		if arg == "save" then
			local backup = io.openlocal("client/windows/explorer.dat", "w+")
			if windbg.value then CONS_Printf(p, "Attempting to write to 'client/windows/explorer.dat'...") end
			backup:write(kart.value, "\n", dx.value, "\n", bubble.value, "\n", token.value, "\n", ssd.value, "\n", funny.value, "\n", funnychance.value, "\n", dxh.value, "\n", dxv.value, "\n", gifty.value)
			backup:close()
			if windbg.value then CONS_Printf(p, "Closing the file handle...") end
			CONS_Printf(p, "\x82\Windows: \x83\Saved server settings.")
			if WindowsTheComputer.DoLocalKartSound then
				S_StartSound(nil, sfx_cpanel, consoleplayer)
			end
			local save = io.openlocal("client/windows/system.dat", "w+")
			if windbg.value then CONS_Printf(p, "Attempting to write to 'client/windows/system.dat'...") end
			if save then
				save:write(music.value, "\n", windbg.value, "\n", dxhudalt.value, "\n", flash.value, "\n", clock.value, "\n", kartsound.value)
				save:close()
				if windbg.value then CONS_Printf(p, "Closing the file handle...") end
				CONS_Printf(p, "\x82\Windows: \x83\Saved client settings.")
			end
		elseif arg == "load" then
			local startupdisk = io.openlocal("client/windows/system.dat")
			if startupdisk then
				local client = 0
				if windbg.value then CONS_Printf(p, "Attempting to read from 'client/windows/system.dat'...") end
				client = startupdisk:read()
				CV_StealthSet(music, client)
				client = startupdisk:read()
				CV_StealthSet(windbg, client)
				client = startupdisk:read()
				CV_StealthSet(dxhudalt, client)
				client = startupdisk:read()
				CV_StealthSet(flash, client)
				client = startupdisk:read()
				CV_StealthSet(clock, client)
				client = startupdisk:read()
				CV_StealthSet(kartsound, client)
				CONS_Printf(p, "\x82\Windows: \x83\Loaded client settings.")
				startupdisk:close()
				if windbg.value then CONS_Printf(p, "Closing the file handle...") end
			else
				local save = io.openlocal("client/windows/system.dat", "w+")
				if save then
					save:write(music.value, "\n", windbg.value, "\n", dxhudalt.value, "\n", flash.value, "\n", clock.value, "\n", kartsound.value)
					save:close()
					CONS_Printf(p, "\x82\Windows: \x85\Client file was not detected, generating one",
								   "\x85\with currently active settings...")
				end
			end
			if not (p == server or isserver or isdedicatedserver) then
				CONS_Printf(p, "\x82\Windows: \x85\You are not the host of this netgame.")
				return
			end
			local update = io.openlocal("client/windows/explorer.dat")
			local patch = 0
			if windbg.value then CONS_Printf(p, "Attempting to read from 'client/windows/explorer.dat'...") end
			patch = update:read()
			CV_StealthSet(kart, patch)
			patch = update:read()
			CV_StealthSet(dx, patch)
			patch = update:read()
			CV_StealthSet(bubble, patch)
			patch = update:read()
			CV_StealthSet(token, patch)
			patch = update:read()
			CV_StealthSet(ssd, patch)
			patch = update:read()
			CV_StealthSet(funny, patch)
			patch = tonumber(update:read())
			if patch < 0 or patch > FRACUNIT then
				CONS_Printf(p, "\x85\Value out of range, using default for 'funindeathchance'.",
							   "\x85\Save the configuration file to no longer see this message.")
				patch = 8192
			end
			patch = fixedToFloat(patch)
			CV_StealthSet(funnychance, patch)
			patch = update:read()
			CV_StealthSet(dxh, patch)
			patch = update:read()
			CV_StealthSet(dxv, patch)
			patch = update:read()
			CV_StealthSet(gifty, patch)
			if WindowsTheComputer.DoLocalKartSound then
				S_StartSound(nil, sfx_cpanel, consoleplayer)
			end
			CONS_Printf(p, "\x82\Windows: \x83\Loaded server settings.")
			update:close()
			if windbg.value then CONS_Printf(p, "Closing the file handle...") end
		else
			CONS_Printf(p, "The syntax of the command is incorrect.")
		end
	else
		CONS_Printf(p, "Using this command, you can manually save/load client/server settings,",
					   "related to \x82\Windows. \x80\Loading server settings requires you to be",
					   "the host of the server. To activate the saving/loading process,",
					   "use\x82\ registry save\x80\ or\x82\ registry load\x80\ respectively.")
	end
end)

COM_AddCommand("msconfig", function(p, arg) // Control that load!
	if arg then
		arg:lower()
		if arg == "0" or arg == "false" or arg == "no" then
			local setup = io.openlocal("client/windows/autoexec.dat", "w+")
			setup:write(0)
			setup:close()
			autoio = false
			if WindowsTheComputer.DoLocalKartSound then
				S_StartSound(nil, sfx_cpanel, consoleplayer)
			end
			CONS_Printf(p, "Automatic save/load disabled.")
		elseif arg == "1" or arg == "true" or arg == "yes" then
			local setup = io.openlocal("client/windows/autoexec.dat", "w+")
			setup:write(1)
			setup:close()
			autoio = true
			if WindowsTheComputer.DoLocalKartSound then
				S_StartSound(nil, sfx_cpanel, consoleplayer)
			end
			CONS_Printf(p, "Automatic save/load enabled.")
		else
			CONS_Printf(p, "Invalid or unknown argument(s) passed to the command.")
		end
	else
		CONS_Printf(p, "Controls automatic save/load for Windows.", "Use\x82\ 0, false, no\x80\ to disable or\x82\ 1, true, yes\x80\ to enable.")
		if autoio then
			CONS_Printf(p, "Currently \x82\enabled\x80\.")
		else
			CONS_Printf(p, "Currently \x82\disabled\x80\.")
		end
	end
end, COM_LOCAL)

// Auto-save.
addHook("GameQuit", function()
	if io.openlocal("client/windows/system.dat") != nil and (autoio) then
		local save = io.openlocal("client/windows/system.dat", "w+")
		save:write(music.value, "\n", windbg.value, "\n", dxhudalt.value, "\n", flash.value, "\n", clock.value)
		save:close()
		if windbg.value then
			if consoleplayer then
				CONS_Printf(consoleplayer, "Auto-save complete.")
			else
				print("Auto-save complete.")
			end
		end
	end
end)

// Auto-load.
local msnclient = io.openlocal("client/windows/system.dat")
if msnclient and autoio then
	if WindowsTheComputer.isdebug then print("Attempting to read from 'client/windows/system.dat'...") end
	local client = 0
	client = msnclient:read()
	CV_StealthSet(music, client)
	client = msnclient:read()
	CV_StealthSet(windbg, client)
	client = msnclient:read()
	CV_StealthSet(dxhudalt, client)
	client = msnclient:read()
	CV_StealthSet(flash, client)
	client = msnclient:read()
	CV_StealthSet(clock, client)
	client = msnclient:read()
	CV_StealthSet(kartsound, client)
	print("\x82\Windows: \x83\Loaded client settings.")
	msnclient:close()
	if windbg.value then print("Closing the file handle...") end
end

// Check what we have.
local function ExternalSupport(p, arg)
	if arg then
		arg:lower()
		if arg == "gift" then
			local gifttable = WindowsTheComputer.GiftCustom
			CONS_Printf(p, "\x82\Windows\x80\ has unique gift functions for:")
			for i = 1, #gifttable
				gifttable[i](p, nil, true)
			end
			if WindowsTheComputer.DoLocalKartSound then
				S_StartSound(nil, sfx_cpanel, consoleplayer)
			end
		elseif arg == "speed" then
			local speedtable = WindowsTheComputer.SpeedSource
			CONS_Printf(p, "\x82\Windows\x80\ has top speed support for:")
			for i = 1, #speedtable
				speedtable[i](p, true)
			end
			if WindowsTheComputer.DoLocalKartSound then
				S_StartSound(nil, sfx_cpanel, consoleplayer)
			end
		elseif arg == "specialform" then
			local customhyper = WindowsTheComputer.HyperDef
			CONS_Printf(p, "\x82\Windows\x80\ has custom (Hyper) forms from:")
			for i = 1, #customhyper
				customhyper[i](p, true)
			end
			if WindowsTheComputer.DoLocalKartSound then
				S_StartSound(nil, sfx_cpanel, consoleplayer)
			end
		else
			CONS_Printf(p, "The syntax of the command is incorrect.")
		end
	else
		CONS_Printf(p, "\x82\Windows\x80\ allows you to add your own top speeds if they exceed Windows' own internal ones. Note that this may",
					   "not work if other momentum mods are present, such as CrossMomentum. In addition, you can also add support for other characters receiving",
					   "gifts should the gifting function be executed, as well as potential Hyper-like forms.",
					   "Valid arguments: gift, speed, specialform")
	end
end
COM_AddCommand("WinPlugins", ExternalSupport)